

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.9.3. TokenFilterStem &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.9.4. TokenFilterStopWord" href="token_filter_stop_word.html" />
    <link rel="prev" title="7.9.2. TokenFilterNFKC100" href="token_filter_nfkc100.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/token_filters/token_filter_stem.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="token_filter_stop_word.html" title="7.9.4. TokenFilterStopWord"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="token_filter_nfkc100.html" title="7.9.2. TokenFilterNFKC100"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../token_filters.html" accesskey="U"><span class="section-number">7.9. </span>Token filters</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.9.3. </span><code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokenfilterstem">
<span id="token-filter-stem"></span><h1><span class="section-number">7.9.3. </span><code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code><a class="headerlink" href="#tokenfilterstem" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.9.3.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code> stems tokenized token.</p>
<p>You need to install an additional package to using <code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code>. For more detail of how to installing an additional package, see <a class="reference external" href="http://groonga.org/docs/install.html">how to install each OS</a> .</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.9.3.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code> has optional parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenFilterStem

TokenFilterStem(&quot;algorithm&quot;, &quot;steming_algorithm&quot;)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.9.3.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is an example that uses <code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code> token filter:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register token_filters/stem
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Memos TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Memos content COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenBigram \
  --normalizer NormalizerAuto \
  --token_filters TokenFilterStem
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms memos_content COLUMN_INDEX|WITH_POSITION Memos content
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Memos
[
{&quot;content&quot;: &quot;I develop Groonga&quot;},
{&quot;content&quot;: &quot;I&#39;m developing Groonga&quot;},
{&quot;content&quot;: &quot;I developed Groonga&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
select Memos --match_columns content --query &quot;develops&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         3
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;content&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;I develop Groonga&quot;
#       ],
#       [
#         2,
#         &quot;I&#39;m developing Groonga&quot;
#       ],
#       [
#         3,
#         &quot;I developed Groonga&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>All of <code class="docutils literal notranslate"><span class="pre">develop</span></code>, <code class="docutils literal notranslate"><span class="pre">developing</span></code>, <code class="docutils literal notranslate"><span class="pre">developed</span></code> and <code class="docutils literal notranslate"><span class="pre">develops</span></code>
tokens are stemmed as <code class="docutils literal notranslate"><span class="pre">develop</span></code>. So we can find <code class="docutils literal notranslate"><span class="pre">develop</span></code>,
<code class="docutils literal notranslate"><span class="pre">developing</span></code> and <code class="docutils literal notranslate"><span class="pre">developed</span></code> by <code class="docutils literal notranslate"><span class="pre">develops</span></code> query.</p>
<p>You can specify steming algorithm except English with <code class="docutils literal notranslate"><span class="pre">algorithm</span></code> option as below.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register token_filters/stem
table_create Memos TABLE_NO_KEY
column_create Memos content COLUMN_SCALAR ShortText
table_create Terms TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenBigram \
  --normalizer NormalizerAuto \
  --token_filters &#39;TokenFilterStem(&quot;algorithm&quot;, &quot;french&quot;)&#39;
column_create Terms memos_content COLUMN_INDEX|WITH_POSITION Memos content
load --table Memos
[
{&quot;content&quot;: &quot;maintenait&quot;},
{&quot;content&quot;: &quot;maintenant&quot;}
]
select Memos --match_columns content --query &quot;maintenir&quot;
# [
#   [
#     0,
#     0.0,
#     0.0
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;content&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;maintenait&quot;
#       ],
#       [
#         2,
#         &quot;maintenant&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.9.3.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<div class="section" id="optional-parameter">
<h3><span class="section-number">7.9.3.4.1. </span>Optional parameter<a class="headerlink" href="#optional-parameter" title="Permalink to this headline">¶</a></h3>
<p>There is a optional parameters <code class="docutils literal notranslate"><span class="pre">algorithm</span></code>.</p>
<div class="section" id="algorithm">
<h4><span class="section-number">7.9.3.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">algorithm</span></code><a class="headerlink" href="#algorithm" title="Permalink to this headline">¶</a></h4>
<p>Specify a steming algorithm.</p>
<p>Steming algorithm is extract the stem. It is prepared for each language.</p>
<p>You can extract the stem of each language by changing steming algorithm.
For example, if you want extract the stem of the French, you specify French to <code class="docutils literal notranslate"><span class="pre">algorithm</span></code> option.</p>
<p>Here are support steming algorithm:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>French
Spanish
Portuguese
Italian
Romanian
German
Dutch
Swedish
Norwegian
Danish
Russian
Finnish
</pre></div>
</div>
</div>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.9.3. <code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.9.3.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.9.3.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.9.3.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.9.3.4. Parameters</a><ul>
<li><a class="reference internal" href="#optional-parameter">7.9.3.4.1. Optional parameter</a><ul>
<li><a class="reference internal" href="#algorithm">7.9.3.4.1.1. <code class="docutils literal notranslate"><span class="pre">algorithm</span></code></a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="token_filter_nfkc100.html"
                        title="previous chapter"><span class="section-number">7.9.2. </span><code class="docutils literal notranslate"><span class="pre">TokenFilterNFKC100</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="token_filter_stop_word.html"
                        title="next chapter"><span class="section-number">7.9.4. </span><code class="docutils literal notranslate"><span class="pre">TokenFilterStopWord</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="token_filter_stop_word.html" title="7.9.4. TokenFilterStopWord"
             >next</a> |</li>
        <li class="right" >
          <a href="token_filter_nfkc100.html" title="7.9.2. TokenFilterNFKC100"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../token_filters.html" ><span class="section-number">7.9. </span>Token filters</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.9.3. </span><code class="docutils literal notranslate"><span class="pre">TokenFilterStem</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>